// @flow

const List = {};

List.append = (item /* : any */) => (arr /* : Array<any> */) => arr.concat([item]);
List.compact = (arr /* : Array<any> */) => arr.filter((x) => x !== null && x !== undefined);
List.filter = (filterer/* : Function */) => (arr /* : Array<any> */) => arr.filter(filterer);
List.head = (arr /* : Array<any> */) => arr[0];
List.indexOf = (item /* : any */) => (arr /* : Array<any> */) => arr.indexOf(item);
List.includes = (item /* : any */) => (arr /* : Array<any> */) => arr.indexOf(item) > -1;
List.insertAt = (index /* : number */) => (item /* : any */) => (arr /* : Array<any> */) => {
	const copy = arr.slice();
	copy.splice(index, 0, item);
	return copy;
};
List.isEmpty = (arr /* : Array<any> */) => arr.length === 0;
List.join = (joiner /* : string */) => (arr /* : Array<any> */) => arr.join(joiner);
List.last = (arr /* : Array<any> */) => arr[arr.length - 1];
List.length = (arr /* : Array<any> */) => arr.length;
List.prepend = (item /* : any */) => (arr /* : Array<any> */) => [item].concat(arr);
List.reduce = (fn /* : Function */) => (arr /* : Array<any> */) => arr.reduce(fn);
List.reduceWithInitial = (fn /* : Function */) => (initialValue /* : any */) => (arr /* : Array<any> */) => arr.reduce(fn, initialValue);
List.reverse = (arr /* : Array<any> */) => arr.slice().reverse();
List.slice = (start /* : number */) => (end /* : number */) => (arr /* : Array<any> */) => arr.slice(start, end);
List.sort = (sorter /* : Function */) => (arr /* : Array<any> */) => arr.slice().sort(sorter);

module.exports = List;